#ifndef ADC_H
#define ADC_H

#define DEBUG_POT

// ADC0 = Vout
#define ADC_MUX_Vo      ADMUX|=0
// ADC0 = VEMK
#define ADC_MUX_VEMK    ADMUX|=0

// ADC6 = SDA = MODE
#define ADC_MUX_MODE    ADMUX|=(1<<MUX1)+(1<<MUX2)


#define ADC_MUX_POT   ADMUX|=(1<<MUX0)
#define ADC_MUX_CLR   ADMUX&=~((1<<MUX0)+(1<<MUX1)+(1<<MUX2))


// SDA is ADC6 !


// max difference to prevoious (10Bit!)
#define ADC_POTDiffMax 10

// POT Offset (R-series ?)
#define ADC_POT_Offset  30

#define ADC_Flag_ADCPOT       (1<<0)
#define ADC_Flag_ADCPOTDONE   (1<<1)
#define ADC_Flag_ADCVO        (1<<2)
#define ADC_Flag_ADCVODONE    (1<<3)
#define ADC_Flag_VoutDone     (1<<4)
#define ADC_Flag_NewValue     (1<<5)
#define ADC_Flag_DEBUG        (1<<6)


//****** Potvalue -2- Drivestep *****//
// (10Bit)
#define ADC_Potval_Step0_min    0
#define ADC_Potval_Step0_max    50
#define ADC_Potval_Step1_max    72
#define ADC_Potval_Step2_max    108
#define ADC_Potval_Step3_max    144
#define ADC_Potval_Step4_max    180
#define ADC_Potval_Step5_max    216
#define ADC_Potval_Step6_max    252
#define ADC_Potval_Step7_max    288
#define ADC_Potval_Step8_max    324
#define ADC_Potval_Step9_max    360
#define ADC_Potval_Step10_max    396
#define ADC_Potval_Step11_max    432
#define ADC_Potval_Step12_max    468
#define ADC_Potval_Step13_max    504
#define ADC_Potval_Step14_max    540
#define ADC_Potval_Step15_max    576
#define ADC_Potval_Step16_max    612
#define ADC_Potval_Step17_max    648
#define ADC_Potval_Step18_max    684
#define ADC_Potval_Step19_max    720
#define ADC_Potval_Step20_max    756
#define ADC_Potval_Step21_max    792
#define ADC_Potval_Step22_max    828
#define ADC_Potval_Step23_max    864
#define ADC_Potval_Step24_max    900
#define ADC_Potval_Step25_max    933
#define ADC_Potval_Step26_max    966
#define ADC_Potval_Step27_max    999




volatile unsigned char ADCFlag;
volatile unsigned int ADC_PotvalOLD;
volatile unsigned char ADC_Potcnt;


volatile unsigned int ADC_Potbuf[9];

void ADC_INIT(void);
void ADC_POT_Task(void);
void ADC_Drivestep2Settings(unsigned char Step,unsigned char *PWM_DC);
unsigned char ADC_Potvale2Drivestep(unsigned int Potvalue);
void ADC_GetPotOffset(void);
void ADC_ExternalMode(void);
/********************************************************/
// Mode Output Voltage
// Vref = 5V; Res = 8Bit; 1LSB =  19.6 mV
// ResistorDivider = 1:5.1 -> 1LSB-Voltage = 100mV 
// Speed = MCLK/32 = 625kHz, ts = 20s

#endif

